diff --git a/src/opencl/lotus5_kernel.cl b/src/opencl/lotus5_kernel.cl
index 639450ae12..9f07d94e1d 100644
--- a/src/opencl/lotus5_kernel.cl
+++ b/src/opencl/lotus5_kernel.cl
@@ -86,12 +86,12 @@ lotus_mix (__private unsigned int *m1, MAYBE_CONSTANT unsigned int *lotus_magic_
 }
 
 __kernel void
-lotus5(__global unsigned int * i_saved_key,
-       constant unsigned int * magic_table
+lotus5(__global lotus5_key *i_saved_key,
+       constant unsigned int *magic_table
 #if !defined(__OS_X__) && gpu_amd(DEVICE_INFO)
 	__attribute__((max_constant_size(256 * sizeof(unsigned int))))
 #endif
-       , __global unsigned int * crypt_key) {
+       , __global unsigned int *crypt_key) {
 
 	unsigned int index = get_global_id(0);
 	unsigned int m32[16];
@@ -115,9 +115,7 @@ lotus5(__global unsigned int * i_saved_key,
 	m32[0] = m32[1] = m32[2] = m32[3] = 0;
 	m32[4] = m32[5] = m32[6] = m32[7] = 0;
 
-	password_length = i_saved_key[
-	                index * KEY_SIZE_IN_ARCH_WORD_32 + KEY_SIZE_IN_ARCH_WORD_32 - 1]
-			>> 24;
+	password_length = i_saved_key[index].l;
 
 	{
 		int i, j;
@@ -135,10 +133,10 @@ lotus5(__global unsigned int * i_saved_key,
 	                             (PLAINTEXT_LENGTH - password_length) << 24;
 		}
 
-	m32[8] = m32[4] ^= i_saved_key[index * KEY_SIZE_IN_ARCH_WORD_32];
-	m32[9] = m32[5] ^= i_saved_key[index * KEY_SIZE_IN_ARCH_WORD_32 + 1];
-	m32[10] = m32[6] ^= i_saved_key[index * KEY_SIZE_IN_ARCH_WORD_32 + 2];
-	m32[11] = m32[7] ^= i_saved_key[index * KEY_SIZE_IN_ARCH_WORD_32 + 3];
+	m32[8] = m32[4] ^= i_saved_key[index].v.w[0];
+	m32[9] = m32[5] ^= i_saved_key[index].v.w[1];
+	m32[10] = m32[6] ^= i_saved_key[index].v.w[2];
+	m32[11] = m32[7] ^= i_saved_key[index].v.w[3];
 
 	lotus_transform_password(m32 + 4, m32 + 12,
 #if cpu(DEVICE_INFO)
diff --git a/src/opencl_lotus5_fmt.h b/src/opencl_lotus5_fmt.h
index 2870332c23..791947fecd 100644
--- a/src/opencl_lotus5_fmt.h
+++ b/src/opencl_lotus5_fmt.h
@@ -3,7 +3,14 @@
 
 #define PLAINTEXT_LENGTH               16
 #define BINARY_SIZE                    16
-#define KEY_SIZE_IN_ARCH_WORD_32       ((PLAINTEXT_LENGTH >> 2) + 1)
 #define BINARY_SIZE_IN_ARCH_WORD_32    (BINARY_SIZE >> 2)
 
+typedef struct {
+	union {
+		char c[PLAINTEXT_LENGTH];
+		unsigned int w[PLAINTEXT_LENGTH / 4];
+	} v;
+	int l;
+} lotus5_key;
+
 #endif
diff --git a/src/opencl_lotus5_fmt_plug.c b/src/opencl_lotus5_fmt_plug.c
index d49a84da33..e55768911c 100644
--- a/src/opencl_lotus5_fmt_plug.c
+++ b/src/opencl_lotus5_fmt_plug.c
@@ -37,7 +37,7 @@ john_register_one(&fmt_opencl_1otus5);
 #define SALT_ALIGN                     1
 #define MIN_KEYS_PER_CRYPT             1
 #define MAX_KEYS_PER_CRYPT             1
-#define KEY_SIZE_IN_BYTES              (((PLAINTEXT_LENGTH >> 2) + 1) << 2)
+#define KEY_SIZE_IN_BYTES              sizeof(lotus5_key)
 
 /*A struct used for JTR's benchmarks*/
 static struct fmt_tests tests[] = {
@@ -84,9 +84,9 @@ static const unsigned int lotus_magic_table[256] = {
 };
 
 /*Some more JTR variables*/
-static cl_uint *crypt_key = NULL;
-static char *saved_key = NULL;
-static struct fmt_main *self = NULL;
+static cl_uint *crypt_key;
+static lotus5_key *saved_key;
+static struct fmt_main *self;
 
 static cl_mem cl_tx_keys, cl_tx_binary, cl_magic_table;
 
@@ -111,7 +111,7 @@ static cl_mem cl_tx_keys, cl_tx_binary, cl_magic_table;
 	v++;			\
 }
 
-static const char * warn[] = {
+static const char *warn[] = {
 	"xfer: ",  ", crypt: ",  ", xfer: "
 };
 
@@ -227,7 +227,7 @@ static void done(void)
 }
 
 /*Utility function to convert hex to bin */
-static void * get_binary(char *ciphertext)
+static void *get_binary(char *ciphertext)
 {
   static char realcipher[BINARY_SIZE];
   int i;
@@ -255,24 +255,23 @@ static int valid (char *ciphertext, struct fmt_main *self)
 /*sets the value of saved_key so we can play with it*/
 static void set_key (char *key, int index)
 {
-  memset (saved_key + index *
-	  KEY_SIZE_IN_BYTES, 0,
-	  KEY_SIZE_IN_BYTES);
-  saved_key[index *
-	    KEY_SIZE_IN_BYTES +
-	    KEY_SIZE_IN_BYTES - 1] = strlen(key);
-  strnzcpy (saved_key + index *
-	    KEY_SIZE_IN_BYTES, key,
-	    saved_key[index *
-	    KEY_SIZE_IN_BYTES +
-	    KEY_SIZE_IN_BYTES - 1] + 1);
+	int len = strlen(key);
 
+	memset(saved_key[index].v.c, 0, PLAINTEXT_LENGTH);
+	memcpy(saved_key[index].v.c, key, len);
+	saved_key[index].l = len;
 }
 
 /*retrieves the saved key; used by JTR*/
-static char * get_key (int index)
+static char *get_key (int index)
 {
-	return (saved_key + index * KEY_SIZE_IN_BYTES);
+	static char out[PLAINTEXT_LENGTH + 1];
+	int len = saved_key[index].l;
+
+	memcpy(out, saved_key[index].v.c, len);
+	out[len] = 0;
+
+	return out;
 }
 
 static int cmp_all (void *binary, int count)
